spago-0.21.0

Safe Haskell | None
Language | Haskell2010

Spago.Types

Synopsis

- newtype PackageName = PackageName {
  - packageName :: Text
  }
- data Package = Package {
  - dependencies :: !(Set PackageName)
  - location :: !PackageLocation
  }
- data PackageLocation
  - = Remote {
    - repo :: !Repo
    - version :: !Text
    }
  - | Local {
    - localPath :: !Text
    }
- data PackageSet = PackageSet {
  - packagesDB :: Map PackageName Package
  - packagesMinPursVersion :: Maybe SemVer
  }
- newtype Repo = Repo {
  - unRepo :: Text
  }
- data Force
  - = Force
  - | NoForce
- data IncludeTransitive
  - = IncludeTransitive
  - | NoIncludeTransitive
- newtype ModuleName = ModuleName {
  - unModuleName :: Text
  }
- newtype TargetPath = TargetPath {
  - unTargetPath :: Text
  }
- newtype SourcePath = SourcePath {
  - unSourcePath :: Text
  }
- newtype PursArg = PursArg {
  - unPursArg :: Text
  }
- newtype BackendArg = BackendArg {
  - unBackendArg :: Text
  }
- data WithMain
  - = WithMain
  - | WithoutMain
- data WithSrcMap
  - = WithSrcMap
  - | WithoutSrcMap
- data Platform
  - = Browser
  - | Node
- data Minify
  - = Minify
  - | NoMinify
- data CacheFlag
  - = SkipCache
  - | NewCache
- data CheckModulesUnique
  - = DoCheckModulesUnique
  - | NoCheckModulesUnique
- data JsonFlag
  - = JsonOutputNo
  - | JsonOutputYes
- data NoSearch
  - = NoSearch
  - | AddSearch
- data OpenDocs
  - = NoOpenDocs
  - | DoOpenDocs
- data UsePsa
  - = UsePsa
  - | NoPsa
- data PathType
  - = PathOutput
  - | PathGlobalCache
- data DepsOnly
  - = DepsOnly
  - | AllSources
- data Watch
  - = Watch
  - | BuildOnce
- data NoBuild
  - = NoBuild
  - | DoBuild
- data NoInstall
  - = NoInstall
  - | DoInstall
- data ClearScreen
  - = DoClear
  - | NoClear
- data AllowIgnored
  - = DoAllowIgnored
  - | NoAllowIgnored
- data ShowVersion
  - = DoShowVersion
  - | NoShowVersion
- data BuildOptions = BuildOptions {
  - shouldWatch :: Watch
  - shouldClear :: ClearScreen
  - allowIgnored :: AllowIgnored
  - sourcePaths :: [SourcePath]
  - withSourceMap :: WithSrcMap
  - noInstall :: NoInstall
  - pursArgs :: [PursArg]
  - depsOnly :: DepsOnly
  - beforeCommands :: [Text]
  - thenCommands :: [Text]
  - elseCommands :: [Text]
  }
- defaultBuildOptions :: BuildOptions
- data BundleOptions = BundleOptions {
  - maybeModuleName :: Maybe ModuleName
  - maybeTargetPath :: Maybe TargetPath
  - maybePlatform :: Maybe Platform
  - minify :: Minify
  - noBuild :: NoBuild
  }
- fromScriptOptions :: BuildOptions -> ScriptBuildOptions -> BuildOptions
- data ScriptBuildOptions = ScriptBuildOptions {
  - pursArgs :: [PursArg]
  - beforeCommands :: [Text]
  - thenCommands :: [Text]
  - elseCommands :: [Text]
  }
- data Config = Config {
  - name :: Text
  - dependencies :: Set PackageName
  - packageSet :: PackageSet
  - alternateBackend :: Maybe Text
  - configSourcePaths :: Set SourcePath
  - publishConfig :: Either (ReadError Void) PublishConfig
  - migrateConfig :: Either (ReadError Void) MigrateConfig
  }
- data MigrateConfig = MigrateConfig {
  - migrateLicense :: Text
  - migrateVersion :: Text
  }
- data PublishConfig = PublishConfig {
  - publishLicense :: Text
  - publishRepository :: Text
  }
- data PursCmd = PursCmd {
  - purs :: Text
  - psa :: Maybe Text
  - compilerVersion :: SemVer
  }
- newtype Jobs = Jobs Int
- newtype ConfigPath = ConfigPath Text
- newtype GitCmd = GitCmd Text
- newtype BowerCmd = BowerCmd Text
- data GlobalCache = GlobalCache !FilePath !(Maybe CacheFlag)
- newtype ModuleGraph = ModuleGraph {
  - unModuleGraph :: Map ModuleName ModuleGraphNode
  }
- data ModuleGraphNode = ModuleGraphNode {
  - graphNodePath :: Text
  - graphNodeDepends :: [ModuleName]
  }
- type Graph = Maybe ModuleGraph

# Documentation

newtype PackageName #

Constructors

PackageName |

Fields

- packageName :: Text

#### Instances

Instances details

FromJSON PackageName # |
Instance details Defined in Spago.Types Methods parseJSON :: Value -> Parser PackageName # parseJSONList :: Value -> Parser [PackageName] # omittedField :: Maybe PackageName #
FromJSONKey PackageName # |
Instance details Defined in Spago.Types Methods fromJSONKey :: FromJSONKeyFunction PackageName # fromJSONKeyList :: FromJSONKeyFunction [PackageName] #
ToJSON PackageName # |
Instance details Defined in Spago.Types Methods toJSON :: PackageName -> Value # toEncoding :: PackageName -> Encoding # toJSONList :: [PackageName] -> Value # toEncodingList :: [PackageName] -> Encoding # omitField :: PackageName -> Bool #
ToJSONKey PackageName # |
Instance details Defined in Spago.Types Methods toJSONKey :: ToJSONKeyFunction PackageName # toJSONKeyList :: ToJSONKeyFunction [PackageName] #
FromDhall PackageName # |
Instance details Defined in Spago.Types Methods autoWith :: InputNormalizer -> Decoder PackageName #
Data PackageName # |

Instance details

Defined in Spago.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> PackageName -> c PackageName #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c PackageName #

toConstr :: PackageName -> Constr #

dataTypeOf :: PackageName -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c PackageName) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c PackageName) #

gmapT :: (forall b. Data b => b -> b) -> PackageName -> PackageName #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> PackageName -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> PackageName -> r #

gmapQ :: (forall d. Data d => d -> u) -> PackageName -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> PackageName -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> PackageName -> m PackageName #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> PackageName -> m PackageName #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> PackageName -> m PackageName #

Read PackageName # |
Instance details Defined in Spago.Types Methods readsPrec :: Int -> ReadS PackageName # readList :: ReadS [PackageName] # readPrec :: ReadPrec PackageName # readListPrec :: ReadPrec [PackageName] #
Show PackageName # |
Instance details Defined in Spago.Types Methods showsPrec :: Int -> PackageName -> ShowS # show :: PackageName -> String # showList :: [PackageName] -> ShowS #
Eq PackageName # |
Instance details Defined in Spago.Types Methods (==) :: PackageName -> PackageName -> Bool # (/=) :: PackageName -> PackageName -> Bool #
Ord PackageName # |
Instance details Defined in Spago.Types Methods compare :: PackageName -> PackageName -> Ordering # (<) :: PackageName -> PackageName -> Bool # (<=) :: PackageName -> PackageName -> Bool # (>) :: PackageName -> PackageName -> Bool # (>=) :: PackageName -> PackageName -> Bool # max :: PackageName -> PackageName -> PackageName # min :: PackageName -> PackageName -> PackageName #

data Package #

A package-set package. Matches the packages definition in Package.dhall from package-sets

Constructors

Package |

Fields

- dependencies :: !(Set PackageName)

  set of dependency package names

- location :: !PackageLocation

  info about where the package is located

#### Instances

Instances details

FromJSON Package # |
Instance details Defined in Spago.Types Methods parseJSON :: Value -> Parser Package # parseJSONList :: Value -> Parser [Package] # omittedField :: Maybe Package #
Generic Package # |

Instance details

Defined in Spago.Types

Associated Types

type Rep Package |

Instance details

Defined in Spago.Types

type Rep Package = D1 ('MetaData "Package" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "Package" 'PrefixI 'True) (S1 ('MetaSel ('Just "dependencies") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Set PackageName)) :*: S1 ('MetaSel ('Just "location") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 PackageLocation)))

Methods

from :: Package -> Rep Package x #

to :: Rep Package x -> Package #

Show Package # |
Instance details Defined in Spago.Types Methods showsPrec :: Int -> Package -> ShowS # show :: Package -> String # showList :: [Package] -> ShowS #
Eq Package # |
Instance details Defined in Spago.Types Methods (==) :: Package -> Package -> Bool # (/=) :: Package -> Package -> Bool #
type Rep Package # |

Instance details

Defined in Spago.Types

type Rep Package = D1 ('MetaData "Package" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "Package" 'PrefixI 'True) (S1 ('MetaSel ('Just "dependencies") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Set PackageName)) :*: S1 ('MetaSel ('Just "location") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 PackageLocation)))

data PackageLocation #

Constructors

Remote |

Fields

- repo :: !Repo

  the remote git repository

- version :: !Text

  version string (also functions as a git ref)

Local |

Fields

- localPath :: !Text

  local path of the package

#### Instances

Instances details

ToJSON PackageLocation # | This instance is to make `spago ls packages --json` work
Instance details Defined in Spago.Types Methods toJSON :: PackageLocation -> Value # toEncoding :: PackageLocation -> Encoding # toJSONList :: [PackageLocation] -> Value # toEncodingList :: [PackageLocation] -> Encoding # omitField :: PackageLocation -> Bool #
Generic PackageLocation # |

Instance details

Defined in Spago.Types

Associated Types

type Rep PackageLocation |

Instance details

Defined in Spago.Types

type Rep PackageLocation = D1 ('MetaData "PackageLocation" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "Remote" 'PrefixI 'True) (S1 ('MetaSel ('Just "repo") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Repo) :*: S1 ('MetaSel ('Just "version") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Text)) :+: C1 ('MetaCons "Local" 'PrefixI 'True) (S1 ('MetaSel ('Just "localPath") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Text)))

Methods

from :: PackageLocation -> Rep PackageLocation x #

to :: Rep PackageLocation x -> PackageLocation #

Show PackageLocation # |
Instance details Defined in Spago.Types Methods showsPrec :: Int -> PackageLocation -> ShowS # show :: PackageLocation -> String # showList :: [PackageLocation] -> ShowS #
Eq PackageLocation # |
Instance details Defined in Spago.Types Methods (==) :: PackageLocation -> PackageLocation -> Bool # (/=) :: PackageLocation -> PackageLocation -> Bool #
type Rep PackageLocation # |

Instance details

Defined in Spago.Types

type Rep PackageLocation = D1 ('MetaData "PackageLocation" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "Remote" 'PrefixI 'True) (S1 ('MetaSel ('Just "repo") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Repo) :*: S1 ('MetaSel ('Just "version") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Text)) :+: C1 ('MetaCons "Local" 'PrefixI 'True) (S1 ('MetaSel ('Just "localPath") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Text)))

data PackageSet #

Constructors

PackageSet |

Fields

- packagesDB :: Map PackageName Package
- packagesMinPursVersion :: Maybe SemVer

#### Instances

Instances details

FromJSON PackageSet # |
Instance details Defined in Spago.Types Methods parseJSON :: Value -> Parser PackageSet # parseJSONList :: Value -> Parser [PackageSet] # omittedField :: Maybe PackageSet #
Generic PackageSet # |

Instance details

Defined in Spago.Types

Associated Types

type Rep PackageSet |

Instance details

Defined in Spago.Types

type Rep PackageSet = D1 ('MetaData "PackageSet" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "PackageSet" 'PrefixI 'True) (S1 ('MetaSel ('Just "packagesDB") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Map PackageName Package)) :*: S1 ('MetaSel ('Just "packagesMinPursVersion") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe SemVer))))

Methods

from :: PackageSet -> Rep PackageSet x #

to :: Rep PackageSet x -> PackageSet #

Show PackageSet # |
Instance details Defined in Spago.Types Methods showsPrec :: Int -> PackageSet -> ShowS # show :: PackageSet -> String # showList :: [PackageSet] -> ShowS #
type Rep PackageSet # |

Instance details

Defined in Spago.Types

type Rep PackageSet = D1 ('MetaData "PackageSet" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "PackageSet" 'PrefixI 'True) (S1 ('MetaSel ('Just "packagesDB") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Map PackageName Package)) :*: S1 ('MetaSel ('Just "packagesMinPursVersion") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe SemVer))))

newtype Repo #

We consider a Repo a "box of source to include in the build" This can have different nature:

Constructors

Repo |

Fields

- unRepo :: Text

#### Instances

Instances details

FromJSON Repo # |
Instance details Defined in Spago.Types Methods parseJSON :: Value -> Parser Repo # parseJSONList :: Value -> Parser [Repo] # omittedField :: Maybe Repo #
ToJSON Repo # |
Instance details Defined in Spago.Types Methods toJSON :: Repo -> Value # toEncoding :: Repo -> Encoding # toJSONList :: [Repo] -> Value # toEncodingList :: [Repo] -> Encoding # omitField :: Repo -> Bool #
FromDhall Repo # |
Instance details Defined in Spago.Types Methods autoWith :: InputNormalizer -> Decoder Repo #
Generic Repo # |

Instance details

Defined in Spago.Types

Associated Types

type Rep Repo |
Instance details Defined in Spago.Types type Rep Repo = D1 ('MetaData "Repo" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'True) (C1 ('MetaCons "Repo" 'PrefixI 'True) (S1 ('MetaSel ('Just "unRepo") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)))

Methods

from :: Repo -> Rep Repo x #

to :: Rep Repo x -> Repo #

Show Repo # |
Instance details Defined in Spago.Types Methods showsPrec :: Int -> Repo -> ShowS # show :: Repo -> String # showList :: [Repo] -> ShowS #
Eq Repo # |
Instance details Defined in Spago.Types Methods (==) :: Repo -> Repo -> Bool # (/=) :: Repo -> Repo -> Bool #
type Rep Repo # |
Instance details Defined in Spago.Types type Rep Repo = D1 ('MetaData "Repo" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'True) (C1 ('MetaCons "Repo" 'PrefixI 'True) (S1 ('MetaSel ('Just "unRepo") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)))

data Force #

Whether to force an action

Constructors

Force |
NoForce |

#### Instances

Instances details

Eq Force # |
Instance details Defined in Spago.Types Methods (==) :: Force -> Force -> Bool # (/=) :: Force -> Force -> Bool #

data IncludeTransitive #

Constructors

IncludeTransitive |
NoIncludeTransitive |

newtype ModuleName #

Constructors

ModuleName |

Fields

- unModuleName :: Text

#### Instances

Instances details

FromJSON ModuleName # |
Instance details Defined in Spago.Types Methods parseJSON :: Value -> Parser ModuleName # parseJSONList :: Value -> Parser [ModuleName] # omittedField :: Maybe ModuleName #
FromJSONKey ModuleName # |
Instance details Defined in Spago.Types Methods fromJSONKey :: FromJSONKeyFunction ModuleName # fromJSONKeyList :: FromJSONKeyFunction [ModuleName] #
Eq ModuleName # |
Instance details Defined in Spago.Types Methods (==) :: ModuleName -> ModuleName -> Bool # (/=) :: ModuleName -> ModuleName -> Bool #
Ord ModuleName # |
Instance details Defined in Spago.Types Methods compare :: ModuleName -> ModuleName -> Ordering # (<) :: ModuleName -> ModuleName -> Bool # (<=) :: ModuleName -> ModuleName -> Bool # (>) :: ModuleName -> ModuleName -> Bool # (>=) :: ModuleName -> ModuleName -> Bool # max :: ModuleName -> ModuleName -> ModuleName # min :: ModuleName -> ModuleName -> ModuleName #

newtype TargetPath #

Constructors

TargetPath |

Fields

- unTargetPath :: Text

newtype SourcePath #

Constructors

SourcePath |

Fields

- unSourcePath :: Text

#### Instances

Instances details

FromDhall SourcePath # |
Instance details Defined in Spago.Types Methods autoWith :: InputNormalizer -> Decoder SourcePath #
Show SourcePath # |
Instance details Defined in Spago.Types Methods showsPrec :: Int -> SourcePath -> ShowS # show :: SourcePath -> String # showList :: [SourcePath] -> ShowS #
Eq SourcePath # |
Instance details Defined in Spago.Types Methods (==) :: SourcePath -> SourcePath -> Bool # (/=) :: SourcePath -> SourcePath -> Bool #
Ord SourcePath # |
Instance details Defined in Spago.Types Methods compare :: SourcePath -> SourcePath -> Ordering # (<) :: SourcePath -> SourcePath -> Bool # (<=) :: SourcePath -> SourcePath -> Bool # (>) :: SourcePath -> SourcePath -> Bool # (>=) :: SourcePath -> SourcePath -> Bool # max :: SourcePath -> SourcePath -> SourcePath # min :: SourcePath -> SourcePath -> SourcePath #

newtype PursArg #

Constructors

PursArg |

Fields

- unPursArg :: Text

#### Instances

Instances details

Show PursArg # |
Instance details Defined in Spago.Types Methods showsPrec :: Int -> PursArg -> ShowS # show :: PursArg -> String # showList :: [PursArg] -> ShowS #
Eq PursArg # |
Instance details Defined in Spago.Types Methods (==) :: PursArg -> PursArg -> Bool # (/=) :: PursArg -> PursArg -> Bool #

newtype BackendArg #

Constructors

BackendArg |

Fields

- unBackendArg :: Text

#### Instances

Instances details

Eq BackendArg # |
Instance details Defined in Spago.Types Methods (==) :: BackendArg -> BackendArg -> Bool # (/=) :: BackendArg -> BackendArg -> Bool #

data WithMain #

Constructors

WithMain |
WithoutMain |

data WithSrcMap #

Constructors

WithSrcMap |
WithoutSrcMap |

data Platform #

Constructors

Browser |
Node |

data Minify #

Constructors

Minify |
NoMinify |

data CacheFlag #

Constructors

SkipCache |
NewCache |

#### Instances

Instances details

Eq CacheFlag # |
Instance details Defined in Spago.Types Methods (==) :: CacheFlag -> CacheFlag -> Bool # (/=) :: CacheFlag -> CacheFlag -> Bool #

data CheckModulesUnique #

Constructors

DoCheckModulesUnique |
NoCheckModulesUnique |

data JsonFlag #

Constructors

JsonOutputNo |
JsonOutputYes |

data NoSearch #

A flag to skip patching the docs using `purescript-docs-search`.

Constructors

NoSearch |
AddSearch |

#### Instances

Instances details

Eq NoSearch # |
Instance details Defined in Spago.Types Methods (==) :: NoSearch -> NoSearch -> Bool # (/=) :: NoSearch -> NoSearch -> Bool #

data OpenDocs #

Flag to open generated HTML documentation in browser

Constructors

NoOpenDocs |
DoOpenDocs |

#### Instances

Instances details

Eq OpenDocs # |
Instance details Defined in Spago.Types Methods (==) :: OpenDocs -> OpenDocs -> Bool # (/=) :: OpenDocs -> OpenDocs -> Bool #

data UsePsa #

Flag to disable the automatic use of `psa`

Constructors

UsePsa |
NoPsa |

data PathType #

The output path that can be obtained via `ls`

Constructors

PathOutput |
PathGlobalCache |

data DepsOnly #

Only build deps and ignore project paths

Constructors

DepsOnly |
AllSources |

#### Instances

Instances details

Eq DepsOnly # |
Instance details Defined in Spago.Types Methods (==) :: DepsOnly -> DepsOnly -> Bool # (/=) :: DepsOnly -> DepsOnly -> Bool #

data Watch #

Constructors

Watch |
BuildOnce |

data NoBuild #

Flag to go through with the build step or skip it, in the case of `bundleApp` and `bundleModule`.

Constructors

NoBuild |
DoBuild |

data NoInstall #

Flag to skip the automatic installation of libraries on build

Constructors

NoInstall |
DoInstall |

#### Instances

Instances details

Eq NoInstall # |
Instance details Defined in Spago.Types Methods (==) :: NoInstall -> NoInstall -> Bool # (/=) :: NoInstall -> NoInstall -> Bool #

data ClearScreen #

Constructors

DoClear |
NoClear |

#### Instances

Instances details

Eq ClearScreen # |
Instance details Defined in Spago.Types Methods (==) :: ClearScreen -> ClearScreen -> Bool # (/=) :: ClearScreen -> ClearScreen -> Bool #

data AllowIgnored #

Flag to allow files ignored via `.gitignore` to trigger a rebuild

Constructors

DoAllowIgnored |
NoAllowIgnored |

data ShowVersion #

Constructors

DoShowVersion |
NoShowVersion |

data BuildOptions #

Constructors

BuildOptions |

Fields

- shouldWatch :: Watch
- shouldClear :: ClearScreen
- allowIgnored :: AllowIgnored
- sourcePaths :: [SourcePath]
- withSourceMap :: WithSrcMap
- noInstall :: NoInstall
- pursArgs :: [PursArg]
- depsOnly :: DepsOnly
- beforeCommands :: [Text]
- thenCommands :: [Text]
- elseCommands :: [Text]

defaultBuildOptions :: BuildOptions #

data BundleOptions #

Constructors

BundleOptions |

Fields

- maybeModuleName :: Maybe ModuleName
- maybeTargetPath :: Maybe TargetPath
- maybePlatform :: Maybe Platform
- minify :: Minify
- noBuild :: NoBuild

fromScriptOptions :: BuildOptions -> ScriptBuildOptions -> BuildOptions #

data ScriptBuildOptions #

Constructors

ScriptBuildOptions |

Fields

- pursArgs :: [PursArg]
- beforeCommands :: [Text]
- thenCommands :: [Text]
- elseCommands :: [Text]

#### Instances

Instances details

Generic ScriptBuildOptions # |

Instance details

Defined in Spago.Types

Associated Types

type Rep ScriptBuildOptions |

Instance details

Defined in Spago.Types

type Rep ScriptBuildOptions = D1 ('MetaData "ScriptBuildOptions" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "ScriptBuildOptions" 'PrefixI 'True) ((S1 ('MetaSel ('Just "pursArgs") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [PursArg]) :*: S1 ('MetaSel ('Just "beforeCommands") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [Text])) :*: (S1 ('MetaSel ('Just "thenCommands") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [Text]) :*: S1 ('MetaSel ('Just "elseCommands") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [Text]))))

Methods

from :: ScriptBuildOptions -> Rep ScriptBuildOptions x #

to :: Rep ScriptBuildOptions x -> ScriptBuildOptions #

Show ScriptBuildOptions # |
Instance details Defined in Spago.Types Methods showsPrec :: Int -> ScriptBuildOptions -> ShowS # show :: ScriptBuildOptions -> String # showList :: [ScriptBuildOptions] -> ShowS #
Eq ScriptBuildOptions # |
Instance details Defined in Spago.Types Methods (==) :: ScriptBuildOptions -> ScriptBuildOptions -> Bool # (/=) :: ScriptBuildOptions -> ScriptBuildOptions -> Bool #
type Rep ScriptBuildOptions # |

Instance details

Defined in Spago.Types

type Rep ScriptBuildOptions = D1 ('MetaData "ScriptBuildOptions" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "ScriptBuildOptions" 'PrefixI 'True) ((S1 ('MetaSel ('Just "pursArgs") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [PursArg]) :*: S1 ('MetaSel ('Just "beforeCommands") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [Text])) :*: (S1 ('MetaSel ('Just "thenCommands") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [Text]) :*: S1 ('MetaSel ('Just "elseCommands") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [Text]))))

data Config #

Spago configuration file type

Constructors

Config |

Fields

- name :: Text
- dependencies :: Set PackageName
- packageSet :: PackageSet
- alternateBackend :: Maybe Text
- configSourcePaths :: Set SourcePath
- publishConfig :: Either (ReadError Void) PublishConfig
- migrateConfig :: Either (ReadError Void) MigrateConfig

#### Instances

Instances details

Generic Config # |

Instance details

Defined in Spago.Types

Associated Types

type Rep Config |

Instance details

Defined in Spago.Types

type Rep Config = D1 ('MetaData "Config" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "Config" 'PrefixI 'True) ((S1 ('MetaSel ('Just "name") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: (S1 ('MetaSel ('Just "dependencies") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Set PackageName)) :*: S1 ('MetaSel ('Just "packageSet") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 PackageSet))) :*: ((S1 ('MetaSel ('Just "alternateBackend") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe Text)) :*: S1 ('MetaSel ('Just "configSourcePaths") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Set SourcePath))) :*: (S1 ('MetaSel ('Just "publishConfig") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Either (ReadError Void) PublishConfig)) :*: S1 ('MetaSel ('Just "migrateConfig") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Either (ReadError Void) MigrateConfig))))))

Methods

from :: Config -> Rep Config x #

to :: Rep Config x -> Config #

Show Config # |
Instance details Defined in Spago.Types Methods showsPrec :: Int -> Config -> ShowS # show :: Config -> String # showList :: [Config] -> ShowS #
type Rep Config # |

Instance details

Defined in Spago.Types

type Rep Config = D1 ('MetaData "Config" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "Config" 'PrefixI 'True) ((S1 ('MetaSel ('Just "name") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: (S1 ('MetaSel ('Just "dependencies") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Set PackageName)) :*: S1 ('MetaSel ('Just "packageSet") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 PackageSet))) :*: ((S1 ('MetaSel ('Just "alternateBackend") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe Text)) :*: S1 ('MetaSel ('Just "configSourcePaths") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Set SourcePath))) :*: (S1 ('MetaSel ('Just "publishConfig") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Either (ReadError Void) PublishConfig)) :*: S1 ('MetaSel ('Just "migrateConfig") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Either (ReadError Void) MigrateConfig))))))

data MigrateConfig #

Extra fields only needed when migrating to the new Spago

Constructors

MigrateConfig |

Fields

- migrateLicense :: Text
- migrateVersion :: Text

#### Instances

Instances details

Generic MigrateConfig # |

Instance details

Defined in Spago.Types

Associated Types

type Rep MigrateConfig |

Instance details

Defined in Spago.Types

type Rep MigrateConfig = D1 ('MetaData "MigrateConfig" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "MigrateConfig" 'PrefixI 'True) (S1 ('MetaSel ('Just "migrateLicense") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: S1 ('MetaSel ('Just "migrateVersion") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)))

Methods

from :: MigrateConfig -> Rep MigrateConfig x #

to :: Rep MigrateConfig x -> MigrateConfig #

Show MigrateConfig # |
Instance details Defined in Spago.Types Methods showsPrec :: Int -> MigrateConfig -> ShowS # show :: MigrateConfig -> String # showList :: [MigrateConfig] -> ShowS #
type Rep MigrateConfig # |

Instance details

Defined in Spago.Types

type Rep MigrateConfig = D1 ('MetaData "MigrateConfig" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "MigrateConfig" 'PrefixI 'True) (S1 ('MetaSel ('Just "migrateLicense") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: S1 ('MetaSel ('Just "migrateVersion") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)))

data PublishConfig #

The extra fields that are only needed for publishing libraries.

Constructors

PublishConfig |

Fields

- publishLicense :: Text
- publishRepository :: Text

#### Instances

Instances details

Generic PublishConfig # |

Instance details

Defined in Spago.Types

Associated Types

type Rep PublishConfig |

Instance details

Defined in Spago.Types

type Rep PublishConfig = D1 ('MetaData "PublishConfig" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "PublishConfig" 'PrefixI 'True) (S1 ('MetaSel ('Just "publishLicense") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: S1 ('MetaSel ('Just "publishRepository") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)))

Methods

from :: PublishConfig -> Rep PublishConfig x #

to :: Rep PublishConfig x -> PublishConfig #

Show PublishConfig # |
Instance details Defined in Spago.Types Methods showsPrec :: Int -> PublishConfig -> ShowS # show :: PublishConfig -> String # showList :: [PublishConfig] -> ShowS #
type Rep PublishConfig # |

Instance details

Defined in Spago.Types

type Rep PublishConfig = D1 ('MetaData "PublishConfig" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "PublishConfig" 'PrefixI 'True) (S1 ('MetaSel ('Just "publishLicense") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: S1 ('MetaSel ('Just "publishRepository") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)))

data PursCmd #

Constructors

PursCmd |

Fields

- purs :: Text
- psa :: Maybe Text
- compilerVersion :: SemVer

#### Instances

Instances details

Generic PursCmd # |

Instance details

Defined in Spago.Types

Associated Types

type Rep PursCmd |

Instance details

Defined in Spago.Types

type Rep PursCmd = D1 ('MetaData "PursCmd" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "PursCmd" 'PrefixI 'True) (S1 ('MetaSel ('Just "purs") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: (S1 ('MetaSel ('Just "psa") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe Text)) :*: S1 ('MetaSel ('Just "compilerVersion") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SemVer))))

Methods

from :: PursCmd -> Rep PursCmd x #

to :: Rep PursCmd x -> PursCmd #

type Rep PursCmd # |

Instance details

Defined in Spago.Types

type Rep PursCmd = D1 ('MetaData "PursCmd" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "PursCmd" 'PrefixI 'True) (S1 ('MetaSel ('Just "purs") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: (S1 ('MetaSel ('Just "psa") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe Text)) :*: S1 ('MetaSel ('Just "compilerVersion") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SemVer))))

newtype Jobs #

Constructors

Jobs Int |

newtype ConfigPath #

Constructors

ConfigPath Text |

newtype GitCmd #

Constructors

GitCmd Text |

newtype BowerCmd #

Constructors

BowerCmd Text |

data GlobalCache #

Constructors

GlobalCache !FilePath !(Maybe CacheFlag) |

newtype ModuleGraph #

Constructors

ModuleGraph |

Fields

- unModuleGraph :: Map ModuleName ModuleGraphNode

#### Instances

Instances details

FromJSON ModuleGraph # |
Instance details Defined in Spago.Types Methods parseJSON :: Value -> Parser ModuleGraph # parseJSONList :: Value -> Parser [ModuleGraph] # omittedField :: Maybe ModuleGraph #

data ModuleGraphNode #

Constructors

ModuleGraphNode |

Fields

- graphNodePath :: Text
- graphNodeDepends :: [ModuleName]

#### Instances

Instances details

FromJSON ModuleGraphNode # |
Instance details Defined in Spago.Types Methods parseJSON :: Value -> Parser ModuleGraphNode # parseJSONList :: Value -> Parser [ModuleGraphNode] # omittedField :: Maybe ModuleGraphNode #
Generic ModuleGraphNode # |

Instance details

Defined in Spago.Types

Associated Types

type Rep ModuleGraphNode |

Instance details

Defined in Spago.Types

type Rep ModuleGraphNode = D1 ('MetaData "ModuleGraphNode" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "ModuleGraphNode" 'PrefixI 'True) (S1 ('MetaSel ('Just "graphNodePath") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: S1 ('MetaSel ('Just "graphNodeDepends") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [ModuleName])))

Methods

from :: ModuleGraphNode -> Rep ModuleGraphNode x #

to :: Rep ModuleGraphNode x -> ModuleGraphNode #

type Rep ModuleGraphNode # |

Instance details

Defined in Spago.Types

type Rep ModuleGraphNode = D1 ('MetaData "ModuleGraphNode" "Spago.Types" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "ModuleGraphNode" 'PrefixI 'True) (S1 ('MetaSel ('Just "graphNodePath") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: S1 ('MetaSel ('Just "graphNodeDepends") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [ModuleName])))

type Graph = Maybe ModuleGraph #